#include <ostream.h>
#include <Tim/adjacency_matrix.h>

/*****************************************************************************/
/* Adjacency matrix                                                          */
/*****************************************************************************/

adjacency_matrix::adjacency_matrix (graph &G) :
	array2<int> (G.number_of_nodes (), G.number_of_nodes ())
{
	node_array<int> V (G);
	node v;
	edge e;
	int i, j;
	int n = G.number_of_nodes ();

	i = low1 ();
	forall_nodes (v, G) {
		V[v] = i;
		i++;
	}
	for (i = low1(); i < n; i++) {
		for (j = low1(); j < n; j++) {
			(*this)(i,j) = 0;
		}
	}
	forall_edges (e, G) {
		i = V[G.source(e)];
		j = V[G.target(e)];
		(*this)(i,j)++;
		if (G.is_undirected ()) {
			(*this)(j,i)++;
		}
	}
}

ostream & operator << (ostream &out, adjacency_matrix &A) {
	int i, j;
	for (i = A.low1 (); i <= A.high1 (); i++) {
		for (j = A.low2 (); j <= A.high2 (); j++) {
			if (i == j) {
				out << "-";
			} else {
				out << A(i,j);
			}
		}
		out << "\n";
	}
	return out;
}
